#pragma once
#include <iostream>
#include<string>
using namespace std;

class HeapStr
{
private:
	char* data;
	int length;
public:
	HeapStr();
	bool StrAssign(string s);
	void Show();
	void StrCopy(HeapStr s);
	bool StrEmpty();
	int StrCompare(HeapStr s);
	int StrLength();
	void SubStr(HeapStr& sub, int pos, int  len);
	void Concat(HeapStr s1, HeapStr s2);
	int Index(HeapStr sub);
	bool ClearStr();
	int IndexKMP(HeapStr sub);
};
// ģʽƥ KMP 㷨
int HeapStr::IndexKMP(HeapStr sub)
{
	int len = sub.length;
	int* next = new int[len + 1];
	for (int k = 0; k <= len; k++)
	{
		next[k] = 0;
	}
	int i = 1, j = 0;
	while (i < len)
	{
		if (j == 0 || sub.data[i] == sub.data[j])
		{
			++i;
			++j;
			next[i] = j;
		}
		else
			j = next[j];
	}
	i = 1, j = 1;
	while (i <= this->length && j <= sub.length)
	{
		if (j == 0)
		{
			++i;
			++j;
		}
		else if (j != 0 && this->data[i - 1] == sub.data[j - 1])
		{
			++i;
			++j;
		}
		else
			j = next[j];
	}
	if (j > sub.length)
		return i - sub.length;
	else
		return -1;
}
// 촮
HeapStr::HeapStr()
{
	data = NULL;
	length = 0;
}
bool HeapStr::StrAssign(string s)
{
	int len = s.length();
	try {
		data = (char*)malloc((len + 1) * sizeof(char));
		for (int i = 0; i < len; i++)
			data[i] = s[i];
		data[len] = '\0';
		length = len;
		return true;
	}
	catch (exception e) {
		cout << e.what() << endl;
		return false;
	}
}
// п
bool HeapStr::StrEmpty()
{
	if (data == NULL)
	{
		cout << "δʼֵ" << endl;
		return true;
	}
	if (length == 0)
		return true;
	return false;
}
int HeapStr::StrLength()
{
	if (data == NULL)
	{
		cout << "δʼֵ" << endl;
		return -1;
	}
	else if (this->StrEmpty())
	{
		cout << "գ" << endl;
		return 0;
	}
	return length;
}
void HeapStr::Show()
{
	if (data == NULL)
	{
		cout << "δʼֵ" << endl;
		return;
	}
	else if (this->StrEmpty() || data[0] == '\0')
	{
		cout << "գ" << endl;
		exit(0);
	}
	cout << data << endl;
}
void HeapStr::StrCopy(HeapStr s)
{
	if (s.length == 0)
	{
		cout << "Ϊմ" << endl;
		return;
	}
	if (s.data == NULL)
	{
		cout << "δʼֵ" << endl;
		exit(0);
	}
	int len = s.length;
	if (this->length < len)
	{
		cout << "̫ض" << endl;
		for (int i = 0; i < length; i++)
			data[i] = s.data[i];
		data[length] = '\0';
	}
	for (int i = 0; i < len; i++)
		data[i] = s.data[i];
	data[len] = '\0';
}
int HeapStr::StrCompare(HeapStr s)
{
	if (data == NULL && s.data == NULL)
	{
		cout << "δʼֵ" << endl;
		exit(0);
	}
	if (this->StrEmpty() == s.StrEmpty())
		return 0;
	int i;
	if (length < s.length)
	{
		for (i = 0; i < length; i++)
		{
			if (data[i] > s.data[i])
				return 1;
			else if (data[i] < s.data[i])
				return -1;
		}
		if (i == length)
			return 0;
	}
	for (i = 0; i < s.length; i++)
	{
		if (data[i] > s.data[i])
			return 1;
		else if (data[i] < s.data[i])
			return -1;
	}
	if (i == s.length)
		return 0;
}
void HeapStr::SubStr(HeapStr& s, int pos, int len)
{
	if (data == NULL)
	{
		cout << "δʼֵ" << endl;
		return;
	}
	else if (this->StrEmpty())
	{
		cout << "գ" << endl;
		return;
	}
	for (int i = 0; i < len; i++)
	{
		s.data[i] = data[i + pos - 1];
	}
	s.data[len] = '\0';
}
void HeapStr::Concat(HeapStr s1, HeapStr s2)
{
	if (data == NULL)
	{
		cout << "δʼֵ" << endl;
		return;
	}
	for (int i = 0; i < s1.length; i++)
		data[i] = s1.data[i];
	for (int j = 0; j < s2.length; j++)
		data[j + s1.length] = s2.data[j];
	data[s1.length + s2.length - 1] = '\0';
}
int HeapStr::Index(HeapStr sub)
{
	if (sub.length > length)
		return -1;
	int i = 0, j = 0;
	while (i < length && j < sub.length)
	{
		if (data[i] == sub.data[j])
		{
			++i;
			++j;
		}
		else
		{
			i = i - j + 2;
			j = 0;
		}
	}
	if (j > sub.length) return i - sub.length;
	else return 0;
}
bool HeapStr::ClearStr()
{
	if (data == NULL)
	{
		cout << "δʼֵ" << endl;
		exit(0);
	}
	if (length == 0)
	{
		return true;
	}
	data[0] = '\0';
	length = 0;
	return true;
}