#pragma once

// ֱӲ
void InsertSortDirectly(int a[], int len)
{
	int i, j;
	for (i = 2; i <= len; i++)
	{
		if (a[i] < a[i - 1])
		{
			// Ϊڱ
			a[0] = a[i];
			for (j = i - 1; a[0] < a[j]; --j)
				a[j + 1] = a[j];
			a[j + 1] = a[0];
		}
	}
}
// ۰
void InsertSortUndirectly(int a[], int len)
{
	int i, j, low, high, mid;
	for (i = 2; i <= len; i++)
	{
		a[0] = a[i];
		low = 1;
		high = i - 1;
		while (low <= high)
		{
			mid = (low + high) / 2;
			if (a[mid] > a[0]) high = mid - 1;
			else low = mid + 1;
		}
		for (j = i - 1; j >= high + 1; --j)
			a[j + 1] = a[j];
		a[high + 1] = a[0];
	}
}
// ϣ
void ShellSort(int a[], int len)
{
	int dk, i, j;
	for (dk = len / 2; dk >= 1; dk = dk / 2) // dk ʾ
	{
		for (i = dk + 1; i <= len; ++i)
		{
			if (a[i] < a[i - dk]) //  a[i] ӱ
			{
				a[0] = a[i];
				for (j = i - dk; j > 0 && a[0] < a[j]; j -= dk)
					a[j + dk] = a[j];   //¼ƣҲλ
				a[j + dk] = a[0];
			}
		}
	}
}
// ð
void BubbleSort(int a[], int len)
{
	// ־Ƿ
	bool flag = false;
	for (int i = 0; i < len - 1; i++)
	{
		flag = false;
		for (int j = len - 1; j > i; j--)
		{
			if (a[j - 1] > a[j])
			{
				int t = a[j - 1];
				a[j - 1] = a[j];
				a[j] = t;
			}
			flag = true;
		}
		if (flag == false)
			return;
	}
}
// 
int Partition(int a[], int low, int high)
{
	int pivot = a[low];
	while (low < high)
	{
		while (low < high && a[high] >= pivot) --high;
		a[low] = a[high];
		while (low < high && a[low] <= pivot) ++low;
		a[high] = a[low];
	}
	a[low] = pivot;
	return low;
}
void QuickSort(int a[], int low, int high)
{
	if (low < high)
	{
		// 
		int pivotpos = Partition(a, low, high);
		QuickSort(a, low, pivotpos - 1);
		QuickSort(a, pivotpos + 1, high);
	}
}
// ˫ð
void DoubleBubbleSort(int a[], int n)
{
	int low = 0, high = n - 1;
	bool flag = true;
	while (low < high&& flag)
	{
		flag = false;
		for (int i = low; i < high; i++)
		{
			if (a[i] > a[i + 1])
			{
				int t = a[i];
				a[i] = a[i + 1];
				a[i + 1] = t;
				flag = true;
			}
		}
		high--;
		for (int j = high; j > low; j--)
		{
			if (a[j] < a[j - 1])
			{
				int t = a[j];
				a[j] = a[j - 1];
				a[j - 1] = t;
				flag = true;
			}
		}
		low++;
	}
}
// ƶżǰ
void Move(int a[], int len)
{
	int i = 0, j = len - 1;
	while (i < j)
	{
		while (i < j && a[i] % 2 != 0)i++;
		while (i < j && a[i] % 2 != 1)j--;
		if (i < j)
		{
			int t = a[i];
			a[i] = a[j];
			a[j] = t;
		}
		i++;
		j--;
	}
}
//ѡȡԪصĿ
int Partition2(int a[], int low, int high)
{
	int rand_index = low + rand() % (high - low + 1);
	int t = a[rand_index];
	a[rand_index] = a[low];
	a[low] = t;
	int i = low;
	int pivot = a[low];
	for (int j = low + 1; j <= high; j++)
	{
		if (a[j] < pivot)
		{
			t = a[++i];
			a[i] = a[j];
			a[j] = t;
		}
	}
	t = a[i];
	a[i] = a[low];
	a[low] = t;
	return i;
}
void QuickSort2(int a[], int low, int high)
{
	if (low < high)
	{
		// 
		int pivotpos = Partition2(a, low, high);
		QuickSort(a, low, pivotpos - 1);
		QuickSort(a, pivotpos + 1, high);
	}
}
// ѡ
void SelectSort(int a[], int n)
{
	int min;
	for (int i = 0; i < n - 1; i++)
	{
		min = i;
		for (int j = i + 1; j < n; j++)
		{
			if (a[j] < a[min])min = j;
		}
		if (min != i)
		{
			int t = a[i];
			a[i] = a[min];
			a[min] = t;
		}
	}
}
//СѸ
// 򣺢ٵ
void MinHeapAdjust(int a[], int k, int len)
{
	a[0] = a[k];
	int i;
	for (i = 2 * k; i <= len; i *= 2)
	{
		if (i < len&& a[i] < a[i + 1])
			i++;
		if (a[0] >= a[i])break;
		else {
			a[k] = a[i];
			k = i;
		}
	}
	a[k] = a[0];
}
//򣺢ڹʼ
void CreateMinHeap(int a[], int len)
{
	for (int i = len / 2; i > 0; i--)
		MinHeapAdjust(a, i, len);
}
//򣺢
void MinHeapSort(int a[], int len)
{
	CreateMinHeap(a, len);
	for (int i = len; i > 1; i--)
	{
		int t = a[i];
		a[i] = a[1];
		a[1] = t;
		MinHeapAdjust(a, 1, i - 1);
	}
}
// Ѹ
// 
void MaxHeapAdjust(int a[], int k, int len)
{
	a[0] = a[k];
	int i;
	for (i = 2 * k; i <= len; i *= 2)
	{
		if (i < len && a[i] > a[i + 1])
			i++;
		if (a[0] <= a[i])break;
		else {
			a[k] = a[i];
			k = i;
		}
	}
	a[k] = a[0];
}
// ʼ
void CreateMaxHeap(int a[], int len)
{
	for (int i = len / 2; i > 0; i--)
		MaxHeapAdjust(a, i, len);
}
// Ѹ
void MaxHeapSort(int a[], int len)
{
	CreateMaxHeap(a, len);
	for (int i = len; i > 1; i--)
	{
		int t = a[i];
		a[i] = a[1];
		a[1] = t;
		MaxHeapAdjust(a, 1, i - 1);
	}
}
// ·鲢
int* b = new int[20];
void Merge(int a[], int low, int mid, int high)
{
	int i, j, k;
	for (k = low; k <= high; k++)
		b[k] = a[k];
	for (i = low, j = mid + 1, k = i; i <= mid && j <= high; k++)
	{
		if (b[i] <= b[j])
			a[k] = b[i++];
		else
			a[k] = b[j++];
	}
	while (i <= mid) a[k++] = b[i++];
	while (j <= high)a[k++] = b[j++];
}
void MergeSort(int a[], int low, int high)
{
	if (low < high)
	{
		int mid = (low + high) / 2;
		MergeSort(a, low, mid);
		MergeSort(a, mid + 1, high);
		Merge(a, low, mid, high);
	}
}